#include <allegro.h>
#include "Personagem.h"
#include "define.h"

Personagem::Personagem (int esq, int dir, int jogador) {
    this->carregar_imagem (jogador);
    if (jogador == 1)
        this->direcao = DIREITA;
    else
        this->direcao = ESQUERDA;
    this->animacao = 0;
    this->lado = PARADO;
    if (jogador == 1)
        this->x = MAX_X/4 - get_size_W()/2;
    else
        this->x = 3*MAX_X/4 - get_size_W()/2;
    this->y = MAX_Y - get_size_H() - 10;
    this->velocidade = 3;
    this->vidas = 3;
    this->morto = false;
    this->morto_counter = 0;
    this->direita = dir;
    this->esquerda = esq;
    this->colisao = false;
}

Personagem::~Personagem () {
    int i, j;
    for (i = 0; i < 2; i++)
    {
        for (j = 0 ; j < 4; j++)
        {
			destroy_bitmap(this->sprite[i][j]);
        }
		destroy_bitmap(*this->sprite[i]);
    }
    destroy_bitmap(**this->sprite);
}


void Personagem::carregar_imagem (int jogador) {
    if (jogador == 1)
    {
        this->sprite[0][0] = this->sprite[0][2] = load_bitmap ("./personagens/P1 - dir.bmp", NULL);
        this->sprite[0][1] = load_bitmap ("./personagens/P1 - dir1.bmp", NULL);
        this->sprite[0][3] = load_bitmap ("./personagens/P1 - dir2.bmp", NULL);
        this->sprite[1][0] = this->sprite[1][2] = load_bitmap ("./personagens/P1 - esq.bmp", NULL);
        this->sprite[1][1] = load_bitmap ("./personagens/P1 - esq1.bmp", NULL);
        this->sprite[1][3] = load_bitmap ("./personagens/P1 - esq2.bmp", NULL);
    }
    else
    {
        this->sprite[0][0] = this->sprite[0][2] = load_bitmap ("./personagens/P2 - dir.bmp", NULL);
        this->sprite[0][1] = load_bitmap ("./personagens/P2 - dir1.bmp", NULL);
        this->sprite[0][3] = load_bitmap ("./personagens/P2 - dir2.bmp", NULL);
        this->sprite[1][0] = this->sprite[1][2] = load_bitmap ("./personagens/P2 - esq.bmp", NULL);
        this->sprite[1][1] = load_bitmap ("./personagens/P2 - esq1.bmp", NULL);
        this->sprite[1][3] = load_bitmap ("./personagens/P2 - esq2.bmp", NULL);
    }
}

void Personagem::processar (BITMAP &buffer) {
    if (this->vidas > 0)
    {
        this->colisaoCima(buffer);
        this->mover (buffer);
        this->desenhar (buffer);
    }
}

void Personagem::mover (BITMAP &buffer) {
    this->lado = PARADO;

    if (key[this->esquerda])
    {
        this->lado |= ESQUERDA;
        if ((!this->colisaoEsquerda(buffer) || this->get_morto()) && this->x > 140) ///Coliso
            this->x -= this->velocidade;
    }

    if (key[this->direita])
    {
        this->lado |= DIREITA;
        if ((!this->colisaoDireita(buffer) || this->get_morto()) && this->x + this->get_size_W() < 498) ///Coliso
            this->x += this->velocidade;

    }
}

void Personagem::desenhar (BITMAP &buffer) {
    if (this->lado == DIREITA || this->lado == ESQUERDA)
    {
        this->direcao = this->lado - 1;
        this->animacao++;
        this->animacao %= 32;
    }
    else
        this->animacao = 0;

    if (colisao && !this->morto) /// verifica se tomou dano
    {
        this->morto = true;
        this->colisao = false;
        this->vidas--;
    }

    if (this->morto)
    {
        this->morto_counter++;
        this->morto_counter %= 100;
        if (!this->morto_counter)
            this->morto = false;
    }

    if (!(this->morto_counter/3%2)) /// o personagem pisca se (morto == true)
        draw_sprite (&buffer, this->get_sprite (), this->x, this->y);
}

BITMAP *Personagem::get_sprite () {
    return this->sprite[this->direcao][(this->animacao + 6)/8%4];
}

int Personagem::get_size_W () {
    return this->sprite[this->direcao][(this->animacao + 6)/8%4]->w;
}

int Personagem::get_size_H () {
    return this->sprite[this->direcao][(this->animacao + 6)/8%4]->h;
}

bool Personagem::get_direcao () {
    switch (this->lado)
    {
        case DIREITA : this->direcao = 0; break;
        case ESQUERDA: this->direcao = 1;
    }
    return this->direcao;
}

char Personagem::get_animacao () {
    if (this->lado == DIREITA || this->lado == ESQUERDA)
        this->animacao++;
    else
        this->animacao = 0;
    this->animacao %= 32;
    return this->animacao;
}

void Personagem::set_direcao (char a) {
    if (!a)
        this->lado = a;
    else
        this->lado |= a;
}

void Personagem::set_vidas (int a) {
    this->vidas = a;
}

int Personagem::get_vidas () {
    return this->vidas;
}

void Personagem::set_morto () {
    this->morto = true;
    this->vidas--;
}

bool Personagem::get_morto () {
    return this->morto;
}

void Personagem::set_morto_counter () {
    if (this->morto)
    {
        this->morto_counter++;
        this->morto_counter %= 100;
        if (!this->morto_counter)
            this->morto = false;
    }
}

int Personagem::get_morto_counter () {
    return this->morto_counter;
}

void Personagem::set_colisao () {
    this->colisao = true;
}

bool Personagem::colisaoEsquerda(BITMAP &buffer){
    int preto = makecol(0,0,0);
    int h = get_size_H();
    for(int i = 0; i < h; i++){
        if(getpixel(&buffer, x, y+i) == preto)
            return true;
    }
    for(int i = 0; i < h; i++){
        if(getpixel(&buffer, x-1, y+i) == preto)
            return true;
    }
//    for(int i = 0; i < h; i++){
//        if(getpixel(&buffer, x-3, y+i) == preto)
//            return true;
//    }
    return false;
}

bool Personagem::colisaoDireita(BITMAP &buffer){
    int preto = makecol(0,0,0);
    int h = get_size_H();
    for(int i = 0; i < h; i++){
        if(getpixel(&buffer, x + this->get_size_W(), y+i) == preto)
            return true;
    }
    for(int i = 0; i < h; i++){
        if(getpixel(&buffer, x + this->get_size_W()+1, y+i) == preto)
            return true;
    }
//    for(int i = 0; i < h; i++){
//        if(getpixel(&buffer, x + this->get_size_W()+2, y+i) == preto)
//            return true;
//    }
    return false;
}

void Personagem::colisaoCima(BITMAP &buffer){
    int preto = makecol(0,0,0);
    if((getpixel(&buffer, this->x +2, this->y-1) == preto || getpixel(&buffer,
    this->x + this->get_size_W()-2 , this->y-1) == preto ) && !this->get_morto()) {
       this->set_colisao();
    }
    if((getpixel(&buffer, this->x +2, this->y-2) == preto || getpixel(&buffer,
    this->x + this->get_size_W()-2 , this->y-2) == preto ) && !this->get_morto()) {
       this->set_colisao();
    }

}
void Personagem::resetarVidas(){
	this->vidas = 3;
	this->morto = false;
	this->morto_counter = 0;
}
